clear all
addpath(genpath('./utilities'));
load('.\data\optimum_parameter_set.mat');   % optimum (best describes the fish's behavior) parameter set
N = 1000;

%% Figure 4
fish_no = 2;
active_sensing = {'predictive_uncertanity'};

frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,3);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

%% Figure 5

fish_no = 2;

active_sensing = {'predictive_uncertanity'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

active_sensing = {'open_loop'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,3);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

active_sensing = {'biswas'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,3);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

%% Statistical analysis (Figure 6 and Table 3)

prs.sig = 1;
prs.shuff = 10000;
prs.pertest = 1;

active_sensing = {'predictive_uncertanity'};

fish_no = 1;
frequency = 0.10;
[sim_f_010_fish1,fish_f_010_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish1,fish_f_015_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish1,fish_f_025_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

fish_no = 2;
frequency = 0.10;
[sim_f_010_fish2,fish_f_010_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish2,fish_f_015_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish2,fish_f_025_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

fish_no = 3;
frequency = 0.10;
[sim_f_010_fish3,fish_f_010_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish3,fish_f_015_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish3,fish_f_025_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

[mmdvalue_predictive_uncertanity(1,1),pvalue_predictive_uncertanity(1,1)] = mmd(fish_f_010_fish1,sim_f_010_fish1,prs);
[mmdvalue_predictive_uncertanity(1,2),pvalue_predictive_uncertanity(1,2)] = mmd(fish_f_015_fish1,sim_f_015_fish1,prs);
[mmdvalue_predictive_uncertanity(1,3),pvalue_predictive_uncertanity(1,3)] = mmd(fish_f_025_fish1,sim_f_025_fish1,prs);

[mmdvalue_predictive_uncertanity(2,1),pvalue_predictive_uncertanity(2,1)] = mmd(fish_f_010_fish2,sim_f_010_fish2,prs);
[mmdvalue_predictive_uncertanity(2,2),pvalue_predictive_uncertanity(2,2)] = mmd(fish_f_015_fish2,sim_f_015_fish2,prs);
[mmdvalue_predictive_uncertanity(2,3),pvalue_predictive_uncertanity(2,3)] = mmd(fish_f_025_fish2,sim_f_025_fish2,prs);

[mmdvalue_predictive_uncertanity(3,1),pvalue_predictive_uncertanity(3,1)] = mmd(fish_f_010_fish3,sim_f_010_fish3,prs);
[mmdvalue_predictive_uncertanity(3,2),pvalue_predictive_uncertanity(3,2)] = mmd(fish_f_015_fish3,sim_f_015_fish3,prs);
[mmdvalue_predictive_uncertanity(3,3),pvalue_predictive_uncertanity(3,3)] = mmd(fish_f_025_fish3,sim_f_025_fish3,prs);

active_sensing = {'open_loop'};

fish_no = 1;
frequency = 0.10;
[sim_f_010_fish1,fish_f_010_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish1,fish_f_015_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish1,fish_f_025_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

fish_no = 2;
frequency = 0.10;
[sim_f_010_fish2,fish_f_010_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish2,fish_f_015_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish2,fish_f_025_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

fish_no = 3;
frequency = 0.10;
[sim_f_010_fish3,fish_f_010_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish3,fish_f_015_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish3,fish_f_025_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

[mmdvalue_open_loop(1,1),pvalue_open_loop(1,1)] = mmd(fish_f_010_fish1,sim_f_010_fish1,prs);
[mmdvalue_open_loop(1,2),pvalue_open_loop(1,2)] = mmd(fish_f_015_fish1,sim_f_015_fish1,prs);
[mmdvalue_open_loop(1,3),pvalue_open_loop(1,3)] = mmd(fish_f_025_fish1,sim_f_025_fish1,prs);

[mmdvalue_open_loop(2,1),pvalue_open_loop(2,1)] = mmd(fish_f_010_fish2,sim_f_010_fish2,prs);
[mmdvalue_open_loop(2,2),pvalue_open_loop(2,2)] = mmd(fish_f_015_fish2,sim_f_015_fish2,prs);
[mmdvalue_open_loop(2,3),pvalue_open_loop(2,3)] = mmd(fish_f_025_fish2,sim_f_025_fish2,prs);

[mmdvalue_open_loop(3,1),pvalue_open_loop(3,1)] = mmd(fish_f_010_fish3,sim_f_010_fish3,prs);
[mmdvalue_open_loop(3,2),pvalue_open_loop(3,2)] = mmd(fish_f_015_fish3,sim_f_015_fish3,prs);
[mmdvalue_open_loop(3,3),pvalue_open_loop(3,3)] = mmd(fish_f_025_fish3,sim_f_025_fish3,prs);


active_sensing = {'biswas'};

fish_no = 1;
frequency = 0.10;
[sim_f_010_fish1,fish_f_010_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish1,fish_f_015_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish1,fish_f_025_fish1] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

fish_no = 2;
frequency = 0.10;
[sim_f_010_fish2,fish_f_010_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish2,fish_f_015_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish2,fish_f_025_fish2] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

fish_no = 3;
frequency = 0.10;
[sim_f_010_fish3,fish_f_010_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.15;
[sim_f_015_fish3,fish_f_015_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);
frequency = 0.25;
[sim_f_025_fish3,fish_f_025_fish3] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,0);

[mmdvalue_biswas(1,1),pvalue_biswas(1,1)] = mmd(fish_f_010_fish1,sim_f_010_fish1,prs);
[mmdvalue_biswas(1,2),pvalue_biswas(1,2)] = mmd(fish_f_015_fish1,sim_f_015_fish1,prs);
[mmdvalue_biswas(1,3),pvalue_biswas(1,3)] = mmd(fish_f_025_fish1,sim_f_025_fish1,prs);

[mmdvalue_biswas(2,1),pvalue_biswas(2,1)] = mmd(fish_f_010_fish2,sim_f_010_fish2,prs);
[mmdvalue_biswas(2,2),pvalue_biswas(2,2)] = mmd(fish_f_015_fish2,sim_f_015_fish2,prs);
[mmdvalue_biswas(2,3),pvalue_biswas(2,3)] = mmd(fish_f_025_fish2,sim_f_025_fish2,prs);

[mmdvalue_biswas(3,1),pvalue_biswas(3,1)] = mmd(fish_f_010_fish3,sim_f_010_fish3,prs);
[mmdvalue_biswas(3,2),pvalue_biswas(3,2)] = mmd(fish_f_015_fish3,sim_f_015_fish3,prs);
[mmdvalue_biswas(3,3),pvalue_biswas(3,3)] = mmd(fish_f_025_fish3,sim_f_025_fish3,prs);

%%% plot

y_max = max([mmdvalue_predictive_uncertanity(:); mmdvalue_open_loop(:); mmdvalue_biswas(:)]);
y_min = min([mmdvalue_predictive_uncertanity(:); mmdvalue_open_loop(:); mmdvalue_biswas(:)]);

h1 = figure('Renderer', 'painters','Units','centimeters');
hold on
plot([0.10 0.20 0.30],mmdvalue_predictive_uncertanity(1,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.8500 0.3250 0.0980],'Color',[0.8500 0.3250 0.0980],'Linewidth',1)
plot([0.10 0.20 0.30],mmdvalue_open_loop(1,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.4660 0.6740 0.1880],'Color',[0.4660 0.6740 0.1880],'Linewidth',1)
plot([0.10 0.20 0.30],mmdvalue_biswas(1,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.4940 0.1840 0.5560],'Color',[0.4940 0.1840 0.5560],'Linewidth',1)
hold off

ax = gca; 
ax.FontSize = 7; 
axis tight 

xlim([0.09 0.31])
xticks([ 0.09 0.10 0.20 0.30])
xticklabels({' ','0.10 Hz','0.15 Hz', '0.25 Hz'})
ylim([y_min y_max])
ylabel('MMD','FontSize',8,'FontName','Helvetica');

legend('predictive uncertainty', 'open-loop','Biswas et al. 2023','FontSize',8,'FontName','Helvetica','Location','best')
legend boxoff

set(h1,"Position",[10 10 6 6])

%%%

h2 = figure('Renderer', 'painters','Units','centimeters');
hold on
plot([0.10 0.20 0.30],mmdvalue_predictive_uncertanity(2,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.8500 0.3250 0.0980],'Color',[0.8500 0.3250 0.0980],'Linewidth',1)
plot([0.10 0.20 0.30],mmdvalue_open_loop(2,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.4660 0.6740 0.1880],'Color',[0.4660 0.6740 0.1880],'Linewidth',1)
plot([0.10 0.20 0.30],mmdvalue_biswas(2,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.4940 0.1840 0.5560],'Color',[0.4940 0.1840 0.5560],'Linewidth',1)
hold off

ax = gca; 
ax.FontSize = 7; 
axis tight 

xlim([0.09 0.31])
xticks([ 0.09 0.10 0.20 0.30])
xticklabels({' ','0.10 Hz','0.15 Hz', '0.25 Hz'})
ylim([y_min y_max])
ylabel('MMD','FontSize',8,'FontName','Helvetica');

legend('predictive uncertainty', 'open-loop','Biswas et al. 2023','FontSize',8,'FontName','Helvetica','Location','best')
legend boxoff

set(h2,"Position",[10 10 6 6])
%%%

h3 = figure('Renderer', 'painters','Units','centimeters');
hold on
plot([0.10 0.20 0.30],mmdvalue_predictive_uncertanity(3,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.8500 0.3250 0.0980],'Color',[0.8500 0.3250 0.0980],'Linewidth',1)
plot([0.10 0.20 0.30],mmdvalue_open_loop(3,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.4660 0.6740 0.1880],'Color',[0.4660 0.6740 0.1880],'Linewidth',1)
plot([0.10 0.20 0.30],mmdvalue_biswas(3,:),'-s','MarkerSize',5,'MarkerFaceColor',[0.4940 0.1840 0.5560],'Color',[0.4940 0.1840 0.5560],'Linewidth',1)
hold off

ax = gca; 
ax.FontSize = 7; 
axis tight 

xlim([0.09 0.31])
xticks([ 0.09 0.10 0.20 0.30])
xticklabels({' ','0.10 Hz','0.15 Hz', '0.25 Hz'})
ylim([y_min y_max])
ylabel('MMD','FontSize',8,'FontName','Helvetica');

legend('predictive uncertainty', 'open-loop','Biswas et al. 2023','FontSize',8,'FontName','Helvetica','Location','best')
legend boxoff

set(h3,"Position",[10 10 6 6])

%% Appendix C 

fish_no = 1;

active_sensing = {'predictive_uncertanity'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

active_sensing = {'open_loop'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

active_sensing = {'biswas'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

fish_no = 3;

active_sensing = {'predictive_uncertanity'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

active_sensing = {'open_loop'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);

active_sensing = {'biswas'};
frequency = 0.10;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.15;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);
frequency = 0.25;
wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,2);


%%
function [sim_f,fish_f] = wrapper_plot(active_sensing,fish_no,frequency,N,optimum_parameter_set,flag)

    % if flag = 1, plot only trajectory. if flag = 2, plot only fft
    % if flag = 3, plot trajectory and fft

    f_handle = str2func(strcat('run_',char(active_sensing),'_mex'));
    optimum_par = optimum_parameter_set.optimum_par(find(ismember(optimum_parameter_set(:,1:3),table(active_sensing,fish_no,frequency))),:);

    [~,fish_p] = loadfishdata(fish_no,frequency);
    [params,model] = init_params(fish_no);
    [t,refuge] = refugeparams2trajectory(1,frequency,params);

    rng shuffle
    rng(415837146);
    [x_all,xf_all,u_all,active_sensing_all,P_all] = f_handle(optimum_par,N,model,params,refuge);
    [sim_f,~] = trajectory2magfreq(reshape(x_all(:,1,:), [size(x_all,1) size(x_all,3)]),params);
    [fish_f,freqaxis] = trajectory2magfreq(fish_p,params);
    
    n_th = 1;
    
    if flag == 1 || flag == 3
        plot_trajectory(t(1:size(x_all,3)),reshape(x_all(n_th,:,:), [4 size(x_all,3)]),reshape(xf_all(n_th,:,:), [4 size(x_all,3)]),fish_p,reshape(P_all(n_th,:,:,:),[4 4 size(x_all,3)]),u_all(n_th,:),active_sensing_all(n_th,:),char(active_sensing))
    end
    if flag == 2 || flag == 3
        plot_fft(sim_f,fish_f,freqaxis,char(active_sensing))
    end
    
end