function [xh,ekf_param] = ekf(xh, u, state_func, meas_func, y, ekf_param)


P_k = ekf_param.P;
Q_k = ekf_param.Q;
R_k = ekf_param.R;
F = ekf_param.F;
L = ekf_param.L;
H = ekf_param.H;

xh = state_func(xh, u);
P_k = F*P_k*F' + L*Q_k*L';

% measurement update
y_tilda = y-meas_func(xh,0);
S_k = H(xh)*P_k*H(xh)'+R_k;
% lh_l =  -0.5*log(2*pi*det(S_k))*0 -0.5*y_tilda'*S_k^-1*y_tilda;    
% lh_n = sqrt(2*pi*det(S_k))^-1*exp(- 0.5*(y_tilda'*S_k^-1*y_tilda));
K_k = P_k*H(xh)'/S_k;
P_k = (eye(length(xh))-K_k*H(xh))*P_k;
xh = xh + K_k*y_tilda;

ekf_param.P = P_k;
% ekf_param.S = S_k;
% ekf_param.lh_l = lh_l;
% ekf_param.lh_l = lh_n;


end