function [testStat,pvalue] = mmd(X,Y,params)
 
m=size(X,1);
n=size(Y,1);

%Set kernel size to median distance between points in aggregate sample
if params.sig == -1
  Z = [X;Y];  %aggregate the sample
  size1=size(Z,1);
    if size1>100
      Zmed = Z(1:100,:);
      size1 = 100;
    else
      Zmed = Z;
    end
    G = sum((Zmed.*Zmed),2);
    Q = repmat(G,1,size1);
    R = repmat(G',size1,1);
    dists = Q + R - 2*(Zmed*Zmed');
    dists = dists-tril(dists);
    dists=reshape(dists,size1^2,1);
    params.sig = sqrt(0.5*median(dists(dists>0)));  %rbf_dot has factor two in kernel
end


K = rbf_dot(X,X,params.sig);
L = rbf_dot(Y,Y,params.sig);
KL = rbf_dot(X,Y,params.sig);

K_XX = K;
K_YY = L;
K_XY = KL;
testStat = (1 / (m * (m - 1))) * sum(sum(K_XX - diag(diag(K_XX)))) + ...
            (1 / (n * (n - 1))) * sum(sum(K_YY - diag(diag(K_YY)))) - ...
            (2 / (m * n)) * sum(sum(K_XY));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if params.pertest==1
    
    permuted_mmds = zeros(params.shuff, 1);
    sig = params.sig;
    
    parfor whichSh = 1:params.shuff
        
        combined_data = [X; Y];
        permuted_data = combined_data(randperm(size(combined_data, 1)), :);
        
        X_perm = permuted_data(1:size(X, 1), :);
        Y_perm = permuted_data(size(X, 1)+1:end, :);
       
        K = rbf_dot(X_perm,X_perm,sig);
        L = rbf_dot(Y_perm,Y_perm,sig);
        KL = rbf_dot(X_perm,Y_perm,sig);

        K_XX = K;
        K_YY = L;
        K_XY = KL;
        permuted_mmds(whichSh) = (1 / (m * (m - 1))) * sum(sum(K_XX - diag(diag(K_XX)))) + ...
                (1 / (n * (n - 1))) * sum(sum(K_YY - diag(diag(K_YY)))) - ...
                (2 / (m * n)) * sum(sum(K_XY));

    end
    pvalue = mean(permuted_mmds >= testStat);
    
end